from inc_noesis import *

def registerNoesisTypes():
    handle = noesis.register("test for moonpaladin", ".example")
    noesis.setHandlerTypeCheck(handle, noepyCheckType)
    noesis.setHandlerLoadModel(handle, noepyLoadModel)
    noesis.setHandlerWriteModel(handle, noepyWriteModel)
    noesis.logPopup()
    return 1
       
def noepyCheckType(data):
    #your code...
    return 1

def noepyLoadModel(data, mdlList):
    bs = NoeBitStream(data)
    #your code...
    mdl = NoeModel()
    mdlList.append(mdl)
    return 1
    
def noepyWriteModel(mdl, bs):
    mesh = mdl.meshes[0]
    magic = "EXAMPLE"
    ver = 1
    
    indices = mesh.indices
    vertex = mesh.positions
    normals = mesh.normals
    uvs = mesh.uvs
    
    bs.writeString(magic, 0)
    bs.writeInt(ver)
    
    bs.writeInt(len(indices))
    bs.writeInt(len(vertex))
    bs.writeInt(len(normals))
    bs.writeInt(len(uvs))
    
    for x in indices:
        bs.writeUShort(x)

    for x in range(len(vertex)):
        [bs.writeFloat(y) for y in vertex[x]]
        if normals:
            [bs.writeFloat(y) for y in normals[x]]
        if uvs:
            [bs.writeFloat(y) for y in uvs[x][:2]]
    return 1
